package net.pingex.dcf.commands;

import sx.blah.discord.handle.obj.IChannel;

import java.util.function.Predicate;

/**
 * CommandScope allows devs to tell where Commands should run.
 * ie. PM, guild chat, etc
 */
public enum CommandScope
{
	/**
	 * Allows only in a guild chat
	 */
	GUILD_CHAT(iChannel -> !iChannel.isPrivate()),

	/**
	 * Only via PM with the bot
	 */
	PRIVATE_MESSAGE(IChannel::isPrivate),

	/**
	 * Allows unconditionally
	 */
	ANYWHERE(iChannel -> true),

	/**
	 * Denies unconditionally
	 * Default value
	 */
	NOWHERE(iChannel -> false);

	private Predicate<IChannel> channel;

	CommandScope(Predicate<IChannel> channel)
	{
		this.channel = channel;
	}

	public boolean test(IChannel iChannel)
	{
		return channel.test(iChannel);
	}
}
